<template>
  <view class="width-100 height-100 view-page">
    <view class="p-10 dis-flex flex-y-center flex-x-between">
      <view class="width-100">
        <u-search :clearabled="true" height="35px" placeholder="请输入搜索关键字" v-model="keyword" shape="round"
          search="doSearch" @custom="doSearch" bg-color="#e9f0f8" placeholder-color="#65371b"></u-search>
      </view>
    </view>
    <view>
    </view>
    <u-tabs ref="tabs" :list="tabList" :scrollable="false" :current="currentTab" @change="tabChange" lineColor="#65371b"
      :activeStyle="{color:'#65371b'}" inactiveStyle="{color:'#65371b'}"></u-tabs>
    <u-list @scrolltolower="scrolltolower" height="calc(100% - 91px)" lowerThreshold="10">
      <view class="info-list">
        <view class="dis-flex flex-x-between info-item" v-for="(item, index) in list" :key="index"
          @click="toDetail(item.id)">
          <view class="info-pic">
            <u-image width="96px" height="96px" mode="aspectFill" :src="item.cover"></u-image>
          </view>
          <view class="info-view">
            <view class="info-title">
              {{item.subTitle}}
            </view>
            <view class="dis-flex info-bottom">
              <view style="margin-right: 20rpx;">{{item.createTime?item.createTime.substring(0,10):''}}</view>
              <u-icon name="thumb-up" color="#7f7f7f" size="18"></u-icon>
              <view style="margin-right: 20rpx;">{{item.likeNum || 0}}点赞</view>
              <u-icon name="eye" color="#7f7f7f" size="18"></u-icon>
              <view>{{item.views || 0}}阅读量</view>
            </view>
          </view>
        </view>
      </view>
      <u-loadmore :status="page.status" :loading-text="page.loadingText" :loadmore-text="page.loadmoreText"
        :nomore-text="page.nomoreText" />
    </u-list>
  </view>
</template>

<script>
  import themeMixins from '@/pages/yuecai/mixins/themeMixins.js';
  export default {
    mixins: [themeMixins],
    data() {
      return {
        tabList: [{
          name: '专业风采'
        }, {
          name: '名店',
        }, {
          name: '名菜'
        }, {
          name: '名点',
        }],
        currentTab: 0,
        //
        page: {
          current: 1,
          size: 10,
          total: 0,
          // loadmore loading nomore
          status: 'loadmore',
          loadingText: '正在加载中',
          loadmoreText: '上拉加载更多',
          nomoreText: '没有更多了'
        },
        keyword: '',
        list: []
      }
    },
    onLoad(options) {
      this.keyword = options.keyword;
    },
    onShow() {
      this.doRefresh();
    },
    methods: {
      tabChange(e) {
        this.currentTab = e.index;
        this.doRefresh();
      },
      scrolltolower() {
        this.loadmore()
      },
      loadmore() {
        this.page.current++;
        this.getList();
      },
      doSearch() {
        this.doRefresh();
      },
      doRefresh() {
        this.page.current = 1;
        this.page.status = 'loadmore'
        this.list = [];
        this.getList();
      },
      getList() {
        if (this.page.status == 'loading' || this.page.status == 'nomore') {
          // 防止重复下拉
          return;
        }
        this.page.status = 'loading';
        //
        let listFunc, params = {};
        switch (this.currentTab) {
          case 0:
            listFunc = this.$u.api.getProfessionalStyleList;
            params.title = this.keyword || '';
            break;
          case 1:
            listFunc = this.$u.api.getRestaurantList;
            params.name = this.keyword || '';
            params.regionId = this.areaCode || '';
            break;
          case 2:
            listFunc = this.$u.api.getDishList;
            params.name = this.keyword || '';
            params.regionId = this.areaCode || '';
            break;
          case 3:
            listFunc = this.$u.api.getSnacksList;
            params.name = this.keyword || '';
            params.regionId = this.areaCode || '';
            break;
          default:
            return;
            break;
        }
        //
        listFunc(this.page.current, this.page.size, params).then(res => {
          if (res.data.records && res.data.records.length > 0) {
            this.list.push(...res.data.records)
          }
          this.page.total = res.data.total || 0;
          if (this.page.size * this.page.current >= res.data.total) {
            this.page.status = 'nomore'
          } else {
            this.page.status = 'loadmore'
          }
        })
      },
      toDetail(id) {
        switch (this.currentTab) {
          case 0:
            uni.navigateTo({
              url: "/pages/yuecai/professional_style/detail/index?id=" + id,
            })
            break;
          case 1:
            uni.navigateTo({
              url: "/pages/yuecai/restaurant/detail/index?id=" + id,
            })
            break;
          case 2:
            uni.navigateTo({
              url: "/pages/yuecai/dish/detail/index?id=" + id,
            })
            break;
          case 3:
            uni.navigateTo({
              url: "/pages/yuecai/snacks/detail/index?id=" + id,
            })
            break;
          default:
            return;
            break;
        }

      },
    },
  }
</script>

<style scoped lang="scss">
  .search-left-btn {
    width: 35px;
    min-width: 35px;
    height: 35px;
    margin-right: 5px;
    box-sizing: border-box;
  }

  .icon-circle {
    border-radius: 50%;
    border: 4rpx solid #65371b;
    display: flex;
    justify-content: center;
    align-items: center;
  }

  .nav-btns {
    border-bottom: 1rpx solid #65371b;
    margin-bottom: 20rpx;
    padding-bottom: 50rpx;

    .nav-btn {
      width: 150rpx;

      .nav-btn-icon {
        margin: auto;
        width: 110rpx;
        height: 110rpx;
      }

      .nav-btn-text {
        width: 100%;
        color: #65371b;
        margin-top: 5rpx;
        font-weight: bolder;
        text-align: center;
      }
    }
  }

  .info-list {
    height: calc(100% - 95px);
    overflow: auto;
    background-color: #f4f6f8;

    .info-item {
      padding: 20rpx;
      border-bottom: 2rpx solid white;

      .info-pic {
        width: 175rpx;
        height: 175rpx;
        background: bisque;
      }

      .info-view {
        width: calc(100% - 205rpx);

        .info-title {
          height: 75px;
          word-break: break-all;
          color: #65371b;
          font-size: 24rpx;
          font-weight: 300;
          line-height: 47rpx;
          word-spacing: 2rpx;
          overflow: hidden;
          text-overflow: -o-ellipsis-lastline;
          overflow: hidden;
          text-overflow: ellipsis;
          display: -webkit-box;
          -webkit-line-clamp: 3;
          line-clamp: 3;
          -webkit-box-orient: vertical;
        }

        .info-bottom {
          color: #7f7f7f;
          font-size: 24rpx;
          margin-top: 10rpx;
        }
      }
    }
  }
</style>